<?php
/**
* Global definitions and some useful functions
*
* @version		$Id: globals.php 366 2010-03-26 12:50:13Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Core
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

//Debug
define('MJFORMS_DEBUG_STATE'   , 1 );
define('MJFORMS_DEBUG'   , 'on' );

define('FEED_COM'   ,  'http://www.mindphp.com/index.php?format=feed&amp;type=rss' );
define('FEED_ADS'   , 'http://www.mindphp.com/index.php?format=feed&amp;type=rss' );

define( 'JFORM_PLUGIN_STORAGE', 0 );
define( 'JFORM_PLUGIN_ELEMENT', 1 );
define( 'JFORM_PLUGIN_EXPORT' , 2 );

define( 'MJFORMS_TYPE_NORMAL'  , 0 );
define( 'MJFORMS_TYPE_PROFILE' , 1 );

define('MJFORMS_FS_PATH'      , JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'files'.DS);
define('MJFORMS_EXPORT_PATH'      , JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'export'.DS);
define('MJFORMS_FS_URL'       , JURI::root().'media/com_mjforms/files/');
define('MJFORMS_XLS_EXPORT'       , JPATH_COMPONENT_ADMINISTRATOR.'/plugins/export/Xls/excel-2.0/');
define('MJFORMS_BACKEND_PATH' , JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_mjforms');
define('MJFORMS_FRONTEND_PATH', JPATH_ROOT.DS.'components'.DS.'com_mjforms');

define('JFORM_SYSTEM_FIELDS','id');

$config = JFactory::getConfig();
define('MJFORMS_TMP_PATH', $config->get('tmp_path'));

//Display errors only if in Debug state
if(MJFORMS_DEBUG_STATE > 0){
        ini_set('display_errors',1);
        error_reporting( E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT);
    }

//Temporary debug function
function d($v){
    if(MJFORMS_DEBUG_STATE>0){
        echo "<pre>";
        var_dump($v);
        echo "</pre>";}
    }

//gets a handle to the global plugin manager object
function &mjformsGetPluginManager(){return $GLOBALS['JFormGlobals']['mjformsPlugin'];}

//Initalizes plugin manager
function mjformsInitializePluginManager(){
    require_once (MJFORMS_BACKEND_PATH.DS.'libraries'.DS.'pluginmanager'.DS.'manager.php');
    $GLOBALS['JFormGlobals'] = array();
    $GLOBALS['JFormGlobals']['mjformsPlugin'] = new mjformsPluginController();
   
    }


if ( !function_exists( 'property_exists' ) ) {
    function property_exists( $class, $property ) {
        if ( is_object( $class ) ) {
            $vars = get_object_vars( $class );
        } else {
            $vars = get_class_vars( $class );
        }
        return array_key_exists( $property, $vars );
    }
}

function _isURL( $url ){
	return preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $url);
}

	
if ((version_compare(phpversion(), '5.0') < 0) && !function_exists( 'clone' ) ) {
    eval('
    function clone($object) {
      return $object;
    }
    ');
}

function indexByHash( $fields ){
		
	$newArray = array();
	foreach( $fields as $f ){
		
		if( !isset( $f->parameters['hash'] ))continue;
		$hash = $f->parameters['hash'];
		$newArray[$hash] = $f;
	}
	return $newArray;

}

/**
 * A utility function that is used to output text that is properly indented for readability.
 *
 * @param string $line the text to be printed to a new line
 * @param int $level the level of indention of the line
 * @return string the passed text indented by "level" tabs
 */
function _line($line, $level)
{
	$tabs = str_repeat( "\t" , $level );
	return $tabs.$line."\n";
}
/**
 * debug  และ Profiler 
 *
 * @param object $var ตัวแปลสำหรับต้องการ debug
 * @param string $file ไฟล์ที่กำลังทำงานอยู่
 * @return null
 */
function mjdebug($var, $file='')
{
    global $_PROFILER, $session;
    if(MJFORMS_DEBUG=='on'){
        if($file!=''){
            //$mark = 'mjdebug_'. $file;
            //$_PROFILER->mark($mark);
        }
        $html = '<pre>' . print_r($var, true) . '</pre><br />';
        $session = JFactory::getSession();
        $mjdebug = 'mjdebug_'.time();
        $session->set($mjdebug, $html);
    }
}