<?php
/*
* @version $Id: feed.php 18162 08-02-2012 15:14:58Z ian $
* @package Joomla
* @subpackage COM_CPS_STAFF
* @copyright Copyright (C) 2012 HOBBYinter. All rights reserved.
* @license GNU/GPL, see LICENSE.php
* @link http://www.mindphp.com/ 
*/
defined('_JEXEC') or die( 'Restricted access' );
require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'globals.php');
 
class FeedHelper{
    
	function render($feed){
            
        $rssurl = $feed['rssurl'];
        $rssitems = 5;
        $rssdesc = 1;
        $rssimage = 1;
        $rssitemdesc = 1;
        $words = 0;
        $rsstitle = 1;
        $rssrtl = 0;
        $cache = 0;
        //$cache_time = $feed['$cache_time'];
        $moduleclass_sfx = '';
        
        
		//  get RSS parsed object
		$options = array();
		$options['rssUrl'] = $rssurl;
		if ($cache) {
			$options['cache_time']  = $cache_time;
			$options['cache_time']	*= 60;
		} else {
			$options['cache_time'] = null;
		}
                
                $config =& JFactory::getConfig();
                $default_language = strtolower($config->getValue('config.language'));
                
		$rssDoc =& JFactory::getXMLparser('RSS', $options);
                
		if ($rssDoc != false){
			// channel header and link
			$channel['title'] = $rssDoc->get_title();
			$channel['link'] = $rssDoc->get_link();
			$channel['description'] = $rssDoc->get_description();

			// channel image if exists
			$image['url'] = $rssDoc->get_image_url();
			$image['title'] = $rssDoc->get_image_title();

			//image handling
			$iUrl 	= isset($image['url']) ? $image['url'] : null;
			$iTitle = isset($image['title']) ? $image['title'] : null;
                        
                        if($rssDoc->get_language() == $default_language) {
                            // items
                            $items = $rssDoc->get_items();

                            // feed elements    
                            $items = array_slice($items, 0, $rssitems);
                        } else {
                            $items = null;
                        }
                        
                        $html = '';

			$html .= '<table cellpadding="0" cellspacing="0" class="moduletable'.$moduleclass_sfx.'">'."\r\n";

			// feed description
			if (!is_null( $channel['title'] ) && $rsstitle) {
				$html .= '<tr>'."\r\n";
				$html .= '<td>'."\r\n";
				$html .= '<strong>'."\r\n";
				$html .= '<a href="'.str_replace( '&', '&amp;', $channel['link']).'" target="_blank">';
				$html .= $channel['title']."\r\n";
                $html .= '</a>'."\r\n";
                $html .= '</strong>'."\r\n";
                $html .= '</td>'."\r\n";
                $html .= '</tr>'."\r\n";
			}

			// feed description
			if ($rssdesc) {
                $html .= '<tr>'."\r\n";
                $html .= '<td>'."\r\n";
                $html .= $channel['description']."\r\n";
                $html .= '</td>'."\r\n";
                $html .= '</tr>'."\r\n";
			}

			// feed image
			if ($rssimage && $iUrl) {
                $html .= '<tr>'."\r\n";
                $html .= '<td align="center">'."\r\n";
                $html .= '<img src="'.$iUrl.'" alt="'.@$iTitle.'"/>'."\r\n";
                $html .= '</td>'."\r\n";
                $html .= '</tr>'."\r\n";

			}

                        $actualItems = count( $items );
			$setItems = $rssitems;

			if ($setItems > $actualItems) {
				$totalItems = $actualItems;
			} else {
				$totalItems = $setItems;
			}

            $html .= '<tr>'."\r\n";
            $html .= '<td>'."\r\n";
            $html .= '<ul class="newsfeed'.$moduleclass_sfx.'"  >'."\r\n";
            $c_rssrtl = '';
				for ($j = 0; $j < $totalItems; $j ++){
					$currItem = & $items[$j];
					// item title
					$html .= '<li>'."\r\n";
					if ( !is_null( $currItem->get_link() ) ) {
						$html .= '<a href="'.$currItem->get_link().'" target="_child">'."\r\n";
						$html .= $currItem->get_title().'</a>'."\r\n";
					}

					// item description
					if ($rssitemdesc)
					{
						// item description
						//$text = html_entity_decode($currItem->get_description());
						$text = str_replace('&apos;', "'", $currItem->get_description());

						// word limit check
						if ($words) {
							$texts = explode(' ', $text);
							$count = count($texts);
							if ($count > $words) {
								$text = '';
								for ($i = 0; $i < $words; $i ++)
								{
									$text .= ' '.$texts[$i];
								}
								$text .= '...';
							}
						}
                                                
                                                $text = preg_replace("/\{\-\-(.+?)\-\-\}/", '', $text); 
                                                
                                                if($c_rssrtl!=''){
                                                    $rssrtl = $c_rssrtl;
                                                }else{
                                                    $rssrtl = 'left';
                                                }
                                                
						$html .= '<div style="text-align: '.$rssrtl.' ! important">'."\r\n";
						$html .= $text."\r\n";
						$html .= '</div>'."\r\n";
					}

					$html .= '</li>'."\r\n";
				}
                $html .= '</ul>'."\r\n";
                $html .= '</td>'."\r\n";
                $html .= '</tr>'."\r\n";
                $html .= '</table>'."\r\n";
		}
        return  $html;
	}
}
