<?php
/**
* Frontend View Helper
* This class is the HTML Workhorse for the frontend
*
* @version		$Id: frontend.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Helpers
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
jimport('joomla.html.pane');

/**
* Frontend View Helper
* This class is the HTML Workhorse for the frontend
 *
 * @package    Joomla
 * @subpackage mjforms.Helpers
*/
class mjformsfrontend{
	
	
	function javascript_validateForm( $form ){

		$pManager =& mjformsGetPluginManager();
		$pManager->loadPlugins('element');
		$output  = _line('<script type="text/javascript">',1);
		$output .= _line('//<![CDATA[',1);
		$output .= _line('function validateForm_'.$form->id.'( form ){',1);
		$output .= _line('var errorArray = new Array();',2);
		$output .= _line('clearErrors_'.$form->id.'();',2);
		foreach( $form->fields as $f )
			$output .= $pManager->invokeMethod('element','jsValidation', array($f->type), array( $f ) ) . "\n";
		$output .= _line('if(errorArray.length){',2);
		$output .= _line('var scroll = new Fx.Scroll(window, {',3);
		$output .= _line('wait: false,',3);
		$output .= _line('duration: 1000,',3);
		$output .= _line('offset: {"x": 0, "y": 0},',3);
		$output .= _line('transition: Fx.Transitions.Quad.easeInOut',3);
		$output .= _line('});',3);
		$output .= _line('scroll.scrollTo(window.getScrollLeft(),errorArray[0].id.getPosition().y);'  ,3);
		//$output .= _line('for(i=0;i<errorArray.length;i++){',3);
		//$output .= _line('',4);
		//$output .= _line('',4);
		//$output .= _line('',4);
		//$output .= _line('}',3);
		$output .= _line('return false;',3);
		$output .= _line('}',2);
		$output .= _line('return true;',2);
		$output .= _line('}',1);
		$output .= _line('//]]>',1);
		$output .= _line('</script>',1);
		echo $output;
		
	}
	
	function javascript_clearErrors( $form ){

		$pManager =& mjformsGetPluginManager();
		$pManager->loadPlugins('element');
		$output  = _line('<script type="text/javascript">',1);
		$output .= _line('//<![CDATA[',1);
		$output .= _line('function clearErrors_'.$form->id.'( form ){',1);
		foreach( $form->fields as $f )
			$output .= $pManager->invokeMethod('element','jsClearErrors', array($f->type), array( $f ) ) . "\n";
		$output .= _line('}',1);
		$output .= _line('//]]>',1);
		$output .= _line('</script>',1);
		echo $output;
		
	}
	
	function elements( $form ){
		$pManager =& mjformsGetPluginManager();
		$pManager->loadPlugins('element');
                $lh = '';
                $lw = '';
                $cw = '';
		foreach ($form->fields as $f ){
                        $c = isset($f->parameters['column'])?$f->parameters['column']:'';
                        if($c == 1 || $c == '') {
                            echo '<div style="clear: both;"></div>';
                        } else {
                            $f->parameters['mw'] = $cw;
                        }
                        
                        $p = isset($f->parameters['below_position'])?$f->parameters['below_position']:'';
                        if($p == 2) {
                            $f->parameters['lh'] = $lh;
                            $f->parameters['lw'] = $lw;
                        }
                        
			echo $pManager->invokeMethod('element','render', array($f->type), array( $f ) );
                        $lh = isset($f->parameters['lh'])?$f->parameters['lh']:$lh;
                        $lw = isset($f->parameters['lw'])?$f->parameters['lw']:$lw;
                        $cw = isset($f->parameters['cw'])?$f->parameters['cw'] + $lw:$cw;
		}
	}
	
	function javascript( $form ){
		JHTML::_( 'behavior.mootools' );
		mjformsFrontend::javascript_clearErrors( $form );
		mjformsFrontend::javascript_validateForm( $form );
	}
	
	function stripSlashes( &$object ){
		$argCount = func_num_args();
		if( $argCount < 2)return;
		$args = func_get_args();
		
		for($i=1;$i<$argCount;$i++){
			if(property_exists($object, $args[$i] )){
				$object->$args[$i] = str_replace( "\\n","\n",$object->$args[$i]);
				$object->$args[$i] = stripSlashes($object->$args[$i]);
			}
		}
	}
}