<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import the Joomla modellist library
jimport('joomla.application.component.modellist');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class mjformsModelExportjforms extends JModelList {
    
    function populateState($ordering = null, $direction = null) {

        // Load the filter state.
        $search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search');
        $this->setState('filter.search', $search);
        
        $ordering = JRequest::getVar('filter_order');
        $direction = JRequest::getVar('filter_order_Dir');
        // List state information.
        parent::populateState($ordering, $direction);
    }
    
    function getListQuery() {
        
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        
        $query->select('m.id AS id, m.title AS title, m.created AS created');
        $query->from('#__mjforms_forms AS m');
        
        $query->select('u.name AS created_by');
        $query->join('left', '#__users AS u ON u.id = m.created_by');
        
        $query->select('p.parameter_value as table_name');
        $query->join('left','#__mjforms_parameters AS p ON p.fid = m.id');
        $query->where('p.plugin_name = '.$db->quote('Database').' AND p.parameter_name = '.$db->quote('tableName'));
        
        $orders = JRequest::getVar('filter_order_Dir');
        $col = JRequest::getVar('filter_order');
        $col = $col == null? 'm.title': $col;
        
        $ordering_o = $this->getState('list.filter_order', $col);
        $query->order($db->escape($ordering_o).' '.$db->escape($this->getState('list.filter_order', $orders)));


        return $query;
        
    }
    
    function exportForms($arr_structure, $arr_records) {
        $db = JFactory::getDbo();
        $prefix = $db->getPrefix();
        
        $structure = '';
        $arr_folders = '';
        foreach ($arr_structure as $id) {
            
            $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_forms')
                    .' WHERE '.$db->nameQuote('id').'='.$id;
            $db->setQuery($query);
            $db->query();
            $forms_rows = $db->loadRowList();
            
            foreach ($forms_rows as $row) {
                $structure .= "INSERT INTO `#__mjforms_forms` (`id`, `title`, `type`, `plugins`, `theme`, `state`, `created`, `created_by`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `groups`, `maximum`, `redirections`) VALUES ('','$row[1]','$row[2]','$row[3]','$row[4]','$row[5]','$row[6]','{admin}','$row[8]','$row[9]','$row[10]','$row[11]','$row[12]','$row[13]','$row[14]','$row[15]','$row[16]')#msplit";
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_fields')
                        .' WHERE '.$db->nameQuote('pid').'='.$id
                        .' ORDER BY id';
                $db->setQuery($query);
                $db->query();
                $fields_rows = $db->loadRowList();
                
                foreach ($fields_rows as $row) {
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $p = count($db->loadRowList());
                    
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $t = count($db->loadRowList());

                    $structure .= "INSERT INTO `#__mjforms_fields`(`id`, `pid`, `type`, `position`) VALUES ('','{fid}','$row[2]','$row[3]')#records".$p."#records".$t."#submsplit";
                }
                $structure .= "#msplit";
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY pid';
                $db->setQuery($query);
                $db->query();
                $parameters_rows = $db->loadRowList();
                
                $column = array('id','uid');
                $split = '';

                $arr_noelement = array('button','html');
                foreach ($parameters_rows as $row) {
                    
                    if($row[5] == 'tableName' && $row[3] == 'Database') {
                        $h_table = $row[6];
                        $arr_folders[] = $h_table;
                    }
                    
                    if($row[5] == 'hash' && !in_array($row[3],$arr_noelement)) {
                        $column[] = $row[6];
                    }
                    
                    if($row[4] == 1 && $split == '') {
                        $structure .= "#msplit";
                        $split = 'ok';
                    }
                    
                    $structure .= "INSERT INTO `#__mjforms_parameters`(`id`, `fid`, `pid`, `plugin_name`, `plugin_type`, `parameter_name`, `parameter_value`) VALUES ('','{fid}','{pid}','$row[3]','$row[4]','$row[5]','$row[6]')#submsplit";
                }
                $structure .= "#msplit";
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY id';
                $db->setQuery($query);
                $db->query();
                $tparameters_rows = $db->loadRowList();
                
                foreach ($tparameters_rows as $row) {
                    $structure .= "INSERT INTO `#__mjforms_tparameters`(`id`, `fid`, `pid`, `plugin_name`, `plugin_type`, `parameter_name`, `parameter_value`) VALUES ('','{fid}','{pid}','$row[3]','$row[4]','$row[5]','$row[6]')#submsplit";
                }
                $structure .= "#msplit";
                
                $query = 'SHOW CREATE TABLE #__mjforms_'.$h_table;
                $db->setQuery($query);
                $rows = $db->loadRowList();
                $structure .= $rows[0][1];
                $structure = str_replace($prefix.'mjforms_'.$h_table, '#__mjforms_'.$h_table, $structure);
                $structure .= "#msplit";
                
                if(in_array($id, $arr_records)) {
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_'.$h_table);
                    $db->setQuery($query);
                    $db->query();
                    $records_rows = $db->loadRowList();
                    foreach ($records_rows as $row) {
                        $f = '';
                        $v = '';
                        for($i = 0, $loop = count($row); $i < $loop; $i++) {
                            $f .= $db->nameQuote($column[$i]).',';
                            $v .= $db->quote($row[$i]).',';
                        }
                        $f = substr($f, 0, strlen($f)-1);
                        $v = substr($v, 0, strlen($v)-1);
                        $structure .= "INSERT INTO ".$db->nameQuote('#__mjforms_'.$h_table)." ($f) VALUES ($v)#submsplit";
                    }
                }
                
                $structure .= "#mjforms-split";
            }
            
        }
        $config = JFactory::getConfig();
        $tmp_path = $config->getValue('tmp_path').DS;
        $f = fopen($tmp_path.'MJForms_Export.sql', 'w+');
        fwrite($f, $structure);
        fclose($f);
        
        return $this->createZip($tmp_path.'MJForms_Export.sql', $tmp_path.'MJForms_Export.zip', $arr_folders);
    }
    
    
    function exportToXML2($arr_structure, $arr_records) {
        $db = JFactory::getDbo();
        $prefix = $db->getPrefix();
        
        $structure = _line('<?xml version="1.0" encoding="UTF-8"?>',0);
        $structure .= _line('<mjforms>',0);
        $arr_folders = '';
        foreach ($arr_structure as $id) {
            $structure .= _line('<mjform>',1);
            $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_forms')
                    .' WHERE '.$db->nameQuote('id').'='.$id;
            $db->setQuery($query);
            $db->query();
            $forms_rows = $db->loadRowList();
            foreach ($forms_rows as $row) {
                $structure .= _line('<mjts>',2);  
                $structure .= _line('<mjt name="#__mjforms_forms">',3);
                $structure .= _line('<mjcs>',4);  
                $structure .= _line('<mjc name="id"></mjc>',5);
                $structure .= _line('<mjc name="title">'.$row[1].'</mjc>',5);
                $structure .= _line('<mjc name="type">'.$row[2].'</mjc>',5);
                $structure .= _line('<mjc name="plugins">'.$row[3].'</mjc>',5);
                $structure .= _line('<mjc name="theme">'.$row[4].'</mjc>',5);
                $structure .= _line('<mjc name="state">'.$row[5].'</mjc>',5);
                $structure .= _line('<mjc name="created">'.$row[6].'</mjc>',5);
                $structure .= _line('<mjc name="created_by">{admin}</mjc>',5);
                $structure .= _line('<mjc name="modified">'.$row[8].'</mjc>',5);
                $structure .= _line('<mjc name="modified_by">'.$row[9].'</mjc>',5);
                $structure .= _line('<mjc name="checked_out">'.$row[10].'</mjc>',5);
                $structure .= _line('<mjc name="checked_out_time">'.$row[11].'</mjc>',5);
                $structure .= _line('<mjc name="publish_up">'.$row[12].'</mjc>',5);
                $structure .= _line('<mjc name="publish_down">'.$row[13].'</mjc>',5);
                $structure .= _line('<mjc name="groups">'.$row[14].'</mjc>',5);
                $structure .= _line('<mjc name="maximum">'.$row[15].'</mjc>',5);
                $structure .= _line('<mjc name="redirections">'.$row[16].'</mjc>',5);
                $structure .= _line('</mjcs>',4);  
                $structure .= _line('</mjt>',3);
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_fields')
                        .' WHERE '.$db->nameQuote('pid').'='.$id
                        .' ORDER BY id';
                $db->setQuery($query);
                $db->query();
                $fields_rows = $db->loadRowList();
                
                foreach ($fields_rows as $row) {
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $p = count($db->loadRowList());
                    
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $t = count($db->loadRowList());
                    
                    $structure .= _line('<mjt name="#__mjforms_fields">',3);
                    $structure .= _line('<mjcs>',4);  
                    $structure .= _line('<mjc name="id"></mjc>',5);
                    $structure .= _line('<mjc name="pid">{fid}</mjc>',5);
                    $structure .= _line('<mjc name="type">'.$row[2].'</mjc>',5);
                    $structure .= _line('<mjc name="position">'.$row[3].'</mjc>',5);
                    $structure .= _line('</mjcs>',4);  
                    $structure .= _line('</mjt>',3);
                    
                    //$structure .= "INSERT INTO `#__mjforms_fields`(`id`, `pid`, `type`, `position`) VALUES ('','{fid}','$row[2]','$row[3]')#records".$p."#records".$t."#submsplit";
                }
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY pid';
                $db->setQuery($query);
                $db->query();
                $parameters_rows = $db->loadRowList();
                
                $column = array('id','uid');
                $split = '';

                $arr_noelement = array('button','html');
                foreach ($parameters_rows as $row) {
                    
                    if($row[5] == 'tableName' && $row[3] == 'Database') {
                        $h_table = $row[6];
                        $arr_folders[] = $h_table;
                    }
                    
                    if($row[5] == 'hash' && !in_array($row[3],$arr_noelement)) {
                        $column[] = $row[6];
                    }
                    
                    if($row[4] == 1 && $split == '') {
                        $split = 'ok';
                    }
                    
                    $structure .= _line('<mjt name="#__mjforms_parameters">',3);
                    $structure .= _line('<mjcs>',4);  
                    $structure .= _line('<mjc name="id"></mjc>',5);
                    $structure .= _line('<mjc name="fid">{fid}</mjc>',5);
                    $structure .= _line('<mjc name="pid">{pid}</mjc>',5);
                    $structure .= _line('<mjc name="plugin_name">'.$row[3].'</mjc>',5);
                    $structure .= _line('<mjc name="plugin_type">'.$row[4].'</mjc>',5);
                    $structure .= _line('<mjc name="parameter_name">'.$row[5].'</mjc>',5);
                    $structure .= _line('<mjc name="parameter_value">'.$row[6].'</mjc>',5);
                    $structure .= _line('</mjcs>',4);  
                    $structure .= _line('</mjt>',3);
                }
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY id';
                $db->setQuery($query);
                $db->query();
                $tparameters_rows = $db->loadRowList();
                
                foreach ($tparameters_rows as $row) {
                    $structure .= _line('<mjt name="#__mjforms_tparameters">',3);
                    $structure .= _line('<mjcs>',4);  
                    $structure .= _line('<mjc name="id"></mjc>',5);
                    $structure .= _line('<mjc name="fid">{fid}</mjc>',5);
                    $structure .= _line('<mjc name="pid">{pid}</mjc>',5);
                    $structure .= _line('<mjc name="plugin_name">'.$row[3].'</mjc>',5);
                    $structure .= _line('<mjc name="plugin_type">'.$row[4].'</mjc>',5);
                    $structure .= _line('<mjc name="parameter_name">'.$row[5].'</mjc>',5);
                    $structure .= _line('<mjc name="parameter_value">'.$row[6].'</mjc>',5);
                    $structure .= _line('</mjcs>',4);  
                    $structure .= _line('</mjt>',3);
                }
                
                $query = 'SHOW CREATE TABLE #__mjforms_'.$h_table;
                $db->setQuery($query);
                $loadrows = $db->loadRowList();
                $create_table = str_replace($prefix, '#__', $loadrows[0][1]);
                $structure .= _line('<mjt name="#__mjforms_'.$h_table.'">',3);
                $structure .= _line('<cmjt name="#__mjforms_'.$h_table.'">',4);
                $structure .= _line($create_table, 5);
                $structure .= _line('</cmjt>',4);
                $structure .= _line('</mjt>',3);
                
                if(in_array($id, $arr_records)) {
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_'.$h_table);
                    $db->setQuery($query);
                    $db->query();
                    $records_rows = $db->loadRowList();
                    foreach ($records_rows as $row) {
                        $structure .= _line('<mjt name="#__mjforms_'.$h_table.'">',3);
                        $structure .= _line('<mjcs>',4);  
                        for($i = 0, $loop = count($row); $i < $loop; $i++) {
                            $structure .= _line('<mjc name="'.$column[$i].'">'.$row[$i].'</mjc>',5);
                        }
                        $structure .= _line('</mjcs>',4);  
                        $structure .= _line('</mjt>',3);
                    }
                }
                $structure .= _line('</mjts>',2);
            }
            $structure .= _line('</mjform>',1);
        }
        $structure .= _line('</mjforms>',0);
        $config = JFactory::getConfig();
        $tmp_path = $config->getValue('tmp_path').DS;
        $f = fopen($tmp_path.'MJForms_Export.xml', 'w+');
        fwrite($f, $structure);
        fclose($f);
        return $this->createZip($tmp_path.'MJForms_Export.xml', $tmp_path.'MJForms_Export.zip', $arr_folders);
    }
    
    function createZip($file, $destination = '', $arr_folders = '') {
        $arr_zip = '';
        if(file_exists($file)) {
            $zip = JArchive::getAdapter('zip');
            foreach ($arr_folders as $main) {
                $path = MJFORMS_FS_PATH . $main;
                if(!JFolder::exists($path)) {
                    continue;
                }
                $dir = JFolder::folders($path);
                foreach ($dir as $sub) {
                    $sub_dir = JFolder::folders($path.DS.$sub);
                    if(count($sub_dir) == 0) {
                        $path_zip = "data/$main/$sub/";
                        $arr_zip[] = array('name' => $path_zip, 'data' => '');
                        continue;
                    }
                    foreach ($sub_dir as $files) {
                        $show_files = JFolder::files($path.DS.$sub.DS.$files);
                        foreach ($show_files as $file_data) {
                            $data = JFile::read($path.DS.$sub.DS.$files.DS.$file_data);
                            $path_zip = "data/$main/$sub/$files/$file_data";
                            $arr_zip[] = array('name' => $path_zip, 'data' => $data);
                        }
                    }
                }
            }

            $data = JFile::read($file);
            $ext = JFile::getExt($file);
            $arr_zip[] = array('name' => 'MJForms_Export.'.$ext, 'data' => $data);
            if($zip->create($destination,$arr_zip,array())) {
                return 'MJForms_Export';
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    function exportToXML($arr_id) {
        $db = JFactory::getDbo();
        $task = JRequest::getVar('task');
        $dom = new DOMDocument('1.0', 'UTF-8');
        $mjforms = $dom->createElement('mjforms');
        $mjforms = $dom->appendChild($mjforms);
        
        $arr_folders = '';
        foreach ($arr_id as $id) {
            $mjform = $dom->createElement('mjform');
            
            $mjts = $dom->createElement('mjts');
            $mjform->appendChild($mjts);
            
            $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_forms')
                    .' WHERE '.$db->nameQuote('id').'='.$id;
            $db->setQuery($query);
            $db->query();
            $forms_rows = $db->loadRowList();
            foreach ($forms_rows as $row) {
                $mjt = $dom->createElement('mjt');
                $mjts->appendChild($mjt);
                $mjt->setAttribute('name', '#__mjforms_forms');
                
                $mjcs = $dom->createElement('mjcs');
                $mjt->appendChild($mjcs);
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'id');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode('');
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'title');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection($row[1]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'type');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[2]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'plugins');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection($row[3]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'theme');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection($row[4]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'state');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[5]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'created');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[6]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'created_by');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection('{admin}');
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'modified');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[8]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'modified_by');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[9]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'checked_out');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[10]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'checked_out_time');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[11]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'publish_up');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[12]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'publish_down');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[13]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'groups');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[14]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'maximum');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createTextNode($row[15]);
                $mjc->appendChild($mjctext);
                
                $mjc = $dom->createElement('mjc');
                $mjc->setAttribute('name', 'redirections');
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection($row[16]);
                $mjc->appendChild($mjctext);
                
                $mjt->appendChild($mjcs);
                $mjts->appendChild($mjt);
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_fields')
                        .' WHERE '.$db->nameQuote('pid').'='.$id
                        .' ORDER BY type';
                $db->setQuery($query);
                $db->query();
                $fields_rows = $db->loadRowList();
                
                foreach ($fields_rows as $row) {
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $p = count($db->loadRowList());
                    
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                            .' WHERE '.$db->nameQuote('pid').'='.$row[0];
                    $db->setQuery($query);
                    $db->query();
                    $t = count($db->loadRowList());
                    
                    $mjt = $dom->createElement('mjt');
                    $mjts->appendChild($mjt);
                    $mjt->setAttribute('name', '#__mjforms_fields');

                    $mjcs = $dom->createElement('mjcs');
                    $mjt->appendChild($mjcs);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'id');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'pid');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection('{fid}');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'type');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[2]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'position');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode($row[3]);
                    $mjc->appendChild($mjctext);
                    
                    $mjt->appendChild($mjcs);
                    $mjts->appendChild($mjt);
                }
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_parameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY plugin_name';
                $db->setQuery($query);
                $db->query();
                $parameters_rows = $db->loadRowList();
                
                $column = array('id','uid');
                $split = '';

                $arr_noelement = array('button','html');
                foreach ($parameters_rows as $row) {
                    
                    if($row[5] == 'tableName' && $row[3] == 'Database') {
                        $h_table = $row[6];
                        $arr_folders[] = $h_table;
                    }
                    
                    if($row[5] == 'hash' && !in_array($row[3],$arr_noelement)) {
                        $column[] = $row[6];
                    }
                    
                    if($row[4] == 1 && $split == '') {
                        $split = 'ok';
                    }
                    
                    $mjt = $dom->createElement('mjt');
                    $mjts->appendChild($mjt);
                    $mjt->setAttribute('name', '#__mjforms_parameters');

                    $mjcs = $dom->createElement('mjcs');
                    $mjt->appendChild($mjcs);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'id');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'fid');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('{fid}');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'pid');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('{pid}');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'plugin_name');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[3]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'plugin_type');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[4]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'parameter_name');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[5]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'parameter_value');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[6]);
                    $mjc->appendChild($mjctext);
                    
                    $mjt->appendChild($mjcs);
                    $mjts->appendChild($mjt);
                }
                
                $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_tparameters')
                        .' WHERE '.$db->nameQuote('fid').'='.$id
                        .' ORDER BY plugin_name';
                $db->setQuery($query);
                $db->query();
                $tparameters_rows = $db->loadRowList();
                
                foreach ($tparameters_rows as $row) {
                    $mjt = $dom->createElement('mjt');
                    $mjts->appendChild($mjt);
                    $mjt->setAttribute('name', '#__mjforms_tparameters');

                    $mjcs = $dom->createElement('mjcs');
                    $mjt->appendChild($mjcs);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'id');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'fid');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('{fid}');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'pid');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createTextNode('{pid}');
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'plugin_name');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[3]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'plugin_type');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[4]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'parameter_name');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[5]);
                    $mjc->appendChild($mjctext);
                    
                    $mjc = $dom->createElement('mjc');
                    $mjc->setAttribute('name', 'parameter_value');
                    $mjcs->appendChild($mjc);
                    $mjctext = $dom->createCDATASection($row[6]);
                    $mjc->appendChild($mjctext);
                    
                    $mjt->appendChild($mjcs);
                    $mjts->appendChild($mjt);
                }
                
                $query = 'SHOW CREATE TABLE #__mjforms_'.$h_table;
                $db->setQuery($query);
                $loadrows = $db->loadRowList();
                $prefix = $db->getPrefix();
                $create_table = str_replace($prefix, '#__', $loadrows[0][1]);
                
                $mjt = $dom->createElement('mjt');
                $mjts->appendChild($mjt);
                $mjt->setAttribute('name', '#__mjforms_'.$h_table);

                $mjc = $dom->createElement('cmjt');
                $mjc->setAttribute('name', '#__mjforms_'.$h_table);
                $mjcs->appendChild($mjc);
                $mjctext = $dom->createCDATASection($create_table);
                $mjc->appendChild($mjctext);
                
                $mjt->appendChild($mjc);
                $mjts->appendChild($mjt);
                
                if($task == 'exportsdata') {
                    $query = 'SHOW COLUMNS FROM '.$db->nameQuote('#__mjforms_'.$h_table);
                    $db->setQuery($query);
                    $db->query();
                    $column = $db->loadResultArray();
                    
                    $query = 'SELECT * FROM '.$db->nameQuote('#__mjforms_'.$h_table);
                    $db->setQuery($query);
                    $db->query();
                    $records_rows = $db->loadRowList();
                    foreach ($records_rows as $row) {
                        $mjt = $dom->createElement('mjt');
                        $mjts->appendChild($mjt);
                        $mjt->setAttribute('name', '#__mjforms_'.$h_table);

                        $mjcs = $dom->createElement('mjcs');
                        $mjt->appendChild($mjcs);
                        for($i = 0, $loop = count($row); $i < $loop; $i++) {
                            $mjc = $dom->createElement('mjc');
                            $mjc->setAttribute('name', $column[$i]);
                            $mjcs->appendChild($mjc);
                            $mjctext = $dom->createTextNode($row[$i]);
                            $mjc->appendChild($mjctext);
                        }
                        $mjt->appendChild($mjcs);
                        $mjts->appendChild($mjt);
                    }
                }
                
            }
            $mjform->appendChild($mjts);
			$mjforms->appendChild($mjform);
        }
        
        $dom->formatOutput = true;
        $structure = $dom->saveXML();
        $config = JFactory::getConfig();
        $tmp_path = $config->getValue('tmp_path').DS;
        $f = fopen($tmp_path.'MJForms_Export.xml', 'w+');
        fwrite($f, $structure);
        fclose($f);
        return $this->createZip($tmp_path.'MJForms_Export.xml', $tmp_path.'MJForms_Export.zip', $arr_folders);
    }
    
}