<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import the Joomla modellist library
jimport('joomla.application.component.model');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.archive');

class mjformsModelImportjforms extends JModel {
    
    function importForms($path_file) {
        $config = JFactory::getConfig();
        $tmp_path = $config->get('tmp_path') . DS;
        JLog::addLogger(array('text_file' => 'mjinstallLog.php'));
        $file_name = md5(time());
        if(JFile::copy($path_file, $tmp_path.$file_name.'.zip')) {
            $file = $tmp_path.$file_name.'.zip';
            $arr = $this->extractZip($file);
            if($arr[1] == 'xml') {
                $result = $this->importXML($arr[0]);
            } else {
                $result = $this->importSql($arr[0]);
            }
            return $result;
        } else {
            return false;
        }
    }
    
    function importSql($data) {
        $user = JFactory::getUser();
        $db = JFactory::getDbo();
        $prefix = $db->getPrefix();
        JLog::addLogger(array('text_file' => 'mjinstallLog.php'));
        $data = str_replace('#__jforms_', $prefix.'mjforms_', $data);
        $data = str_replace('#__mjforms_', $prefix.'mjforms_', $data);
        $import_data = explode('#mjforms-split', $data);
        foreach ($import_data as $form) {
            if($form == '') {
                continue;
            }
            $tables = explode("#msplit", $form);
            $query_forms = str_replace('{admin}', $user->id, $tables[0]);
            $db->setQuery($query_forms);
            $db->query();
            if($db->getErrorMsg()) {
                JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
            }
            $fid = $db->insertid();

            $fields = str_replace('{fid}', $fid, $tables[1]);
            $data = str_replace('{fid}', $fid, $tables[2]);
            $parameter = str_replace('{fid}', $fid, $tables[3]);
            $tparameter = str_replace('{fid}', $fid, $tables[4]);

            $data = str_replace('{pid}', 0, $data);
            $arr_data = explode("#submsplit", $data);

            foreach ($arr_data as $query) {
                if(!empty($query)) {
                    $db->setQuery($query);
                    $db->query();
                    if($db->getErrorMsg()) {
                        JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
                    }
                }
            }

            $table_fields = explode("#submsplit", $fields);

            $i = 0;
            $j = 0;
            $p = 0;
            $t = 0;
            foreach ($table_fields as $query) {
                $query = explode('#records', $query);
                $p += $query[1];
                $t += $query[2];
                if(!empty($query[0])) {
                    $db->setQuery($query[0]);
                    $db->query();
                    if($db->getErrorMsg()) {
                        JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
                    }

                    $pid = $db->insertid();
                    $arr_p = explode("#submsplit", $parameter);
                    $arr_t = explode("#submsplit", $tparameter);
                    while ($i < $p) {
                        $query_p = str_replace('{pid}', $pid, $arr_p[$i]);
                        $db->setQuery($query_p);
                        $db->query();
                        if($db->getErrorMsg()) {
                            JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
                        }
                        $i++;
                    }
                    while ($j < $t) {
                        $query_t = str_replace('{pid}', $pid, $arr_t[$j]);
                        $db->setQuery($query_t);
                        $db->query();
                        if($db->getErrorMsg()) {
                            JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
                        }
                        $j++;
                    }
                }
            }
            $db->setQuery($tables[5]);
            $db->query();
            if($db->getErrorMsg()) {
                JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
            }

            if(count($tables) == 7) {
                $records = explode("#submsplit", $tables[6]);
                foreach ($records as $query) {
                    if($query == '') {
                        continue;
                    }
                    $db->setQuery($query);
                    $db->query();
                    if($db->getErrorMsg()) {
                        JLog::add(__LINE__.'Error;;->'.$db->getErrorMsg());
                    }
                }
            }
        }
        return true;
    }
    
    function importXML($param) {
        $config = JFactory::getConfig();
        $dbname = $config->get('db');
        $prefig = $config->get('dbprefix');
        $user = JFactory::getUser();
        $db = JFactory::getDbo();
        $create_tables = $param['create_tables'];
        if(count($create_tables) > 0) {
            foreach ($create_tables as $table_name => $query_table) {
                $table_name = str_replace('#__', $prefig, $table_name);
                $db->setQuery("SELECT table_name FROM information_schema.tables WHERE table_schema = '$dbname' AND table_name = '$table_name'");
                $db->query();
                $result = $db->loadResult();
                if(!empty($result)) {
                    return false;
                }
                $query = str_replace('CREATE TABLE', 'CREATE TABLE IF NOT EXISTS', $query_table);
                $db->setQuery($query);
                $db->query();
            }
        }

        $data = $param['tables'];
        $name_form = '';
        $plugin_name = '';
        $parameter_value = '';
        foreach ($data as $mjform) {
            $table_name = $mjform[0];
            if(!isset($mjform[1])) {
                continue;
            }
            $table_fields = $mjform[1];
            $table_values =$mjform[2];
            if($table_name == '#__mjforms_forms' && $name_form != $table_values[1]) {
                $name_form = $table_values[1];
                $fid = 0;
                $pid = array();
                $pp = -1;
                $tp = -1;
            }
            
            $query = 'INSERT INTO '.$db->nameQuote($table_name).' (';
            foreach ($table_fields as $field) {
                $query .= $db->nameQuote($field).',';
            }
            $query = substr($query, 0, strlen($query) - 1);
            $query .= ') VALUES (';
            if($table_name == '#__mjforms_parameters' || $table_name == '#__mjforms_tparameters') {
                if($table_values[3] == 'Database' || $table_values[3] == 'Mail') {
                    $table_values[2] = '0';
                } else {
                    if(($table_values[5] == 'hash' && $table_name == '#__mjforms_parameters') || ($table_name == '#__mjforms_tparameters' && $table_values[5] == 'label')) {
                        if($table_name == '#__mjforms_parameters') {
                            $pp++;
                        } else {
                            $tp++;
                        }
                        $plugin_name = $table_values[3];
                        $parameter_value = $table_values[6];
                    }
                }
            }
            foreach ($table_values as $values) {
                if($values == '{admin}') {
                    $values = $user->id;
                }
                if($values == '{fid}') {
                    $values = $fid;
                }
                if($values == '{pid}' && $table_name == '#__mjforms_tparameters') {
                    if(isset($pid[$tp])) {
                        $values = $pid[$tp];
                    }
                } else if($values == '{pid}' && $table_name == '#__mjforms_parameters') {
                    if(isset($pid[$pp])) {
                        $values = $pid[$pp];
                    }
                }
                $query .= $db->quote($values).',';
                
            }
            $query = substr($query, 0, strlen($query) - 1);
            $query .= ')';
            $db->setQuery($query);
            $db->query();
            if($table_name == '#__mjforms_forms') {
                $fid = $db->insertid();
            } else if($table_name == '#__mjforms_fields') {
                $pid[] = $db->insertid();
            }
        }
        return true;
    }
    
    function extractZip($file) {
        $config = JFactory::getConfig();
        $tmp_path = $config->get('tmp_path') . DS;
        $zip = JArchive::getAdapter('zip');
        
        if(JFolder::exists($tmp_path.'data')) {
            JFolder::delete($tmp_path.'data');
        }
        
        $files_del = JFolder::files($tmp_path);
        foreach ($files_del as $file_del) {
            $ext_del = JFile::getExt($file_del);
            if($ext_del == 'xml') {
                JFile::delete($tmp_path.$file_del);
            }
        }
        
        if(!$zip->extract($file,$tmp_path)) {
            return false;
        }
        if(JFolder::exists($tmp_path.'data')) {
            $folders = JFolder::folders($tmp_path.'data');
            foreach ($folders as $folder) {
                JFolder::copy($tmp_path.'data'.DS.$folder, MJFORMS_FS_PATH.$folder,'',true);
            }
        }
        
        $files = JFolder::files($tmp_path);
        if(in_array('MJForms_Export.xml', $files)) {
            $ext = 'xml';
            $file = 'MJForms_Export.xml';
            $data = $this->xmlToArray($tmp_path . 'MJForms_Export.xml');
        } else {
            $ext = 'sql';
            $data = file_get_contents($tmp_path . 'MJForms_Export.sql');
        }
        
        $files_del = JFolder::files($tmp_path);
        foreach ($files_del as $file_del) {
            $ext_del = JFile::getExt($file_del);
            if($ext_del == 'zip' || $ext_del == 'xml') {
                JFile::delete($tmp_path.$file_del);
            }
        }
        return array($data, $ext);
    }
    
    function xmlToArray($file_path) {
        $content_xml = file_get_contents($file_path);
        $xml = simplexml_load_string($content_xml, 'SimpleXMLElement');
        //$xml = $xml->children()->children()->children();
        $xml = $xml->children();
        $tables = array();
        $rows = array();
        $tempRow = array();
        $tempCells = array();
        $crate_table = array();
        if (@count($xml->children())) {
            foreach ($xml as $v0) {
                foreach ($v0->mjts->mjt as $k1 => $v1) {
                    $tbl_attr = $v1->attributes();
                    $isInTables = false;
                    if(in_array((string)$tbl_attr['name'], $tables)) {
                        $isInTables = true;
                    }

                    if ($isInTables == false) {
                        $tables[] = array((string)$tbl_attr['name']);
                    }
                    if(isset($v1->mjcs->mjc)) {
                        foreach ($v1->mjcs->mjc as $k2 => $v2) {
                            $row_attr = $v2->attributes();
                            if (!array_search((string)$row_attr['name'], $tempRow))
                            {
                                $tempRow[] = (string)$row_attr['name'];
                            }
                            $tempCells[] = (string)$v2;
                        }
                        $rows[] = array((string)$tbl_attr['name'], $tempRow, $tempCells);
                        $tempRow = array();
                        $tempCells = array();
                    } 

                    if(isset($v1->cmjt)) {
                        foreach ($v1 as $k2 => $v2) {
                            $row_attr = $v2->attributes();
                            $key = (string)$row_attr['name'];
                            $crate_table[$key] = (string) $v2;
                        }
                    }
                }
            }
            unset($tempRow);
            unset($tempCells);
            unset($xml);

            /**
             * Bring accumulated rows into the corresponding table
             */
//            $num_tbls = count($tables);
//            for ($i = 0; $i < $num_tbls; ++$i) {
//                for ($j = 0; $j < count($rows); ++$j) {
//                    if($tables[$i][0] == $rows[$j][0]) {
//                        if(!isset($tables[$i][1])) {
//                            $tables[$i][1] = $rows[$j][1];
//                        }
//                        $tables[$i][2][] = $rows[$j][2];
//                    }
//                }
//            }
//            unset($rows);
        }
        return array('tables' => $rows, 'create_tables' => $crate_table);
    }
    
}